//===========================================================================================//
//                     @           _CNgRcn֐  @    @                           //
//===========================================================================================//
LPDIRECT3D2         pD3D       = NULL;
LPDIRECT3DDEVICE2   pD3DDevice = NULL;
LPDIRECT3DVIEWPORT2 pD3DVP     = NULL;

//eNX`nϐ
D3DTexture*         pTexture   = NULL;
D3DTEXTUREHANDLE    hTexture;

//Cgnϐ
LPDIRECT3DMATERIAL2 pD3DMat    = NULL;
LPDIRECT3DLIGHT     pD3DLight  = NULL;
D3DMATERIALHANDLE   hMaterial;

/*************************************************************************/
/*                    DirectDrawhCo񋓊֐@                       */
/*************************************************************************/
BOOL CALLBACK DDEnumCallback(GUID FAR* lpGUID, LPSTR lpDriverDesc, LPSTR lpDriverName, LPVOID lpContext)
{
    LPDIRECTDRAW lpDD;
    DDCAPS DriverCaps, HELCaps;

    // DirectDraw IuWFNgIɐ
    if ( DirectDrawCreate(lpGUID, &lpDD, NULL) != DD_OK ) {
       *(LPDIRECTDRAW*)lpContext = NULL;
       return DDENUMRET_OK;
    }

    // DirectDraw̔\͂擾
    ZeroMemory(&DriverCaps, sizeof(DDCAPS));
    DriverCaps.dwSize = sizeof(DDCAPS);
    ZeroMemory(&HELCaps, sizeof(DDCAPS));
    HELCaps.dwSize = sizeof(DDCAPS);

    if (lpDD->GetCaps(&DriverCaps, &HELCaps) == DD_OK) {
        // n[hEFA3Dx҂łꍇŁD
        // ȂeNX`gpłꍇg
        if ((DriverCaps.dwCaps & DDCAPS_3D) && (DriverCaps.ddsCaps.dwCaps & DDSCAPS_TEXTURE)) {
            *(LPDIRECTDRAW*)lpContext = lpDD;
			//lstrcpy(szDDDeviceName, lpDriverDesc);
            return DDENUMRET_CANCEL;
        }
    }

    // ̃hCo
    *(LPDIRECTDRAW*)lpContext = NULL;
    RELEASE(lpDD);

    return DDENUMRET_OK;
}

/*************************************************************************/
/*                     _CNgRc֐@                        */
/*************************************************************************/
bool D3D_INIT(HWND hwnd)
{
	HRESULT ret;

	//Direct3D IMIuWFNg̍쐬
	ret = DDObject->QueryInterface(IID_IDirect3D2,(void**)&pD3D);
	if(ret != DD_OK){
		MessageBox( hwnd, "IM","", MB_OK);
		return FALSE;
	}

	// Z Buffer
	LPDIRECTDRAWSURFACE	pOldScreen;
	DDSURFACEDESC ddsd;
	D3DFINDDEVICESEARCH findSearch;
	D3DFINDDEVICERESULT findResult;

	// Rcn[hEFA@\̗L𒲂ׂ
	ZeroMemory(&findSearch,sizeof(findSearch));
	findSearch.dwSize = sizeof(findSearch);
	findSearch.dwFlags = D3DFDS_HARDWARE;
	findSearch.bHardware = TRUE;
	ZeroMemory(&findResult,sizeof(findResult));
	findResult.dwSize = sizeof(findResult);
	ret = pD3D->FindDevice(&findSearch,&findResult);

	// obNEobt@rfIEɂ邩ǂ𒲂ׂ
	DDSCAPS caps;
	DDBack->GetCaps(&caps);
	BOOL zsys = caps.dwCaps & DDSCAPS_VIDEOMEMORY;

	ZeroMemory(&ddsd,sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(DDSURFACEDESC);
	ddsd.dwFlags = DDSD_CAPS | DDSD_ZBUFFERBITDEPTH | DDSD_HEIGHT | DDSD_WIDTH;
	if(ret == DD_OK && zsys)
	    ddsd.ddsCaps.dwCaps = DDSCAPS_VIDEOMEMORY | DDSCAPS_ZBUFFER;
	else
	    ddsd.ddsCaps.dwCaps = DDSCAPS_SYSTEMMEMORY | DDSCAPS_ZBUFFER;
	ddsd.dwWidth = 640;
	ddsd.dwHeight = 480;
	ddsd.dwZBufferBitDepth = 16;

	ret = DDObject->CreateSurface(&ddsd,&pOldScreen,NULL);
	if(ret==DD_OK)
		ret = pOldScreen->QueryInterface(IID_IDirectDrawSurface3, (LPVOID*)&pZBuffer);
	RELEASE(pOldScreen);
	if(ret==DD_OK)
		DDBack->AddAttachedSurface(pZBuffer);
	else {
		return FALSE;
	}

	/*---------------------------------------------------------
		D3DfoCX̎擾
		HAL , MMX , RGB ̗D揇()Ŏ擾eXg
	----------------------------------------------------------*/
	//HAL
	ret = pD3D->CreateDevice(IID_IDirect3DHALDevice, (LPDIRECTDRAWSURFACE)DDBack, &pD3DDevice);
	if(ret != DD_OK){
	//MMX
		ret = pD3D->CreateDevice(IID_IDirect3DMMXDevice, (LPDIRECTDRAWSURFACE)DDBack, &pD3DDevice);
	}
	if(ret != DD_OK){
	//RGB
		ret = pD3D->CreateDevice(IID_IDirect3DRGBDevice, (LPDIRECTDRAWSURFACE)DDBack, &pD3DDevice);
	}

	if(ret != DD_OK)	return FALSE;		//s


	//r[|[g̍쐬,ݒ
	D3DVIEWPORT2 vp;
	ZeroMemory(&vp,sizeof(vp));
	vp.dwSize = sizeof(vp);
	vp.dwX = 0;
	vp.dwY = 0;
	vp.dwWidth = 640;
	vp.dwHeight = 480;
	vp.dvClipX = -1.0f;
	vp.dvClipWidth = 2.0f;
	vp.dvClipY = (float)480/(float)640;
	vp.dvClipHeight = vp.dvClipY * 2.0f;
	vp.dvMinZ = 0.0f;
	vp.dvMaxZ = 1.0f;

	pD3D->CreateViewport(&pD3DVP,NULL);
	pD3DDevice->AddViewport(pD3DVP);
	pD3DDevice->SetCurrentViewport(pD3DVP);
	pD3DVP->SetViewport2(&vp);

	return TRUE;	
}

/*-------------------------------------------
	Ȉ
--------------------------------------------*/
void D3D_END(void)
{
	RELEASE(pD3DMat);
	if(pD3DLight != NULL) pD3DVP->DeleteLight(pD3DLight);
	RELEASE(pD3DLight);

	delete pTexture; pTexture = NULL;
	RELEASE(pD3DVP);
	RELEASE(pD3DDevice);
	RELEASE(pD3D);
}

