typedef struct _tag_bitmap256_ {
	BITMAPINFOHEADER bmiHeader;
	RGBQUAD bmiColors[256];
}BITMAPINFO256;


LPDIRECTDRAWSURFACE3 CreateBitmapSurface(LPDIRECTDRAW2 pDDraw,char* name,DWORD ddsCaps);
int SetSurfaceColorKey(LPDIRECTDRAWSURFACE3 pSurface, COLORREF rgb);
HBITMAP LoadBitmapImage(char* name);
int CopyBitmapToSurface(LPDIRECTDRAWSURFACE3 pSurface,HBITMAP hBitmap);
LPDIRECTDRAWPALETTE CreatePaletteFromBitmap(LPDIRECTDRAW2 pDDraw,HBITMAP hBitmap);

/*-----------------------------------------------------
	rbg}bvT[tF[X쐬
-------------------------------------------------------*/
LPDIRECTDRAWSURFACE3 CreateBitmapSurface(LPDIRECTDRAW2 pDDraw,char* name,DWORD ddsCaps)
{
	DDSURFACEDESC ddsd;
	HRESULT ret;
	HBITMAP hBitmap;
	LPDIRECTDRAWSURFACE pSurface = NULL;
	LPDIRECTDRAWSURFACE3 pS3;
	BITMAP bm;

	ZeroMemory(&ddsd,sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(DDSURFACEDESC);
	ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
	ddsd.ddsCaps.dwCaps = ddsCaps;

	hBitmap = LoadBitmapImage(name);
	if(hBitmap == NULL)
		return NULL;

	GetObject(hBitmap,sizeof(bm),&bm);

	ddsd.dwWidth = bm.bmWidth;
	ddsd.dwHeight = bm.bmHeight;

	ret = pDDraw->CreateSurface(&ddsd,&pSurface,NULL);
	if(ret==DD_OK)
		ret = pSurface->QueryInterface(IID_IDirectDrawSurface3, (LPVOID*)&pS3);
	pSurface->Release();
	if(ret != DD_OK){
		DeleteObject(hBitmap);
		return NULL;
	}

	//8rbg̏ꍇ̓pbg쐬
	if(bm.bmBitsPixel == 8){
		pS3->SetPalette(CreatePaletteFromBitmap(pDDraw,hBitmap));
	}

	CopyBitmapToSurface(pS3,hBitmap);
	DeleteObject(hBitmap);

	return pS3;
}

/*---------------------------------------------------------
	rbg}bvǂݍ
----------------------------------------------------------*/
HBITMAP LoadBitmapImage(char* name)
{
	HBITMAP hBmp;
	// n߂ɁC\[XTD
	hBmp = (HBITMAP)LoadImage(GetModuleHandle(NULL), name, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
	// \[XȂ΁Ct@CT
	if (hBmp == NULL)
	    hBmp = (HBITMAP)LoadImage(NULL, name, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION);

	return hBmp;
}


/*--------------------------------------------------------
	T[tF[XɃrbg}bvRs[
---------------------------------------------------------*/
int CopyBitmapToSurface(LPDIRECTDRAWSURFACE3 pSurface,HBITMAP hBitmap)
{
	HDC hdc,hdcBitmap;
	HBITMAP hbmOld;
	BITMAP bm;
	HRESULT ret;

	GetObject(hBitmap,sizeof(bm),&bm);

	hdcBitmap = CreateCompatibleDC(NULL);
	hbmOld = (HBITMAP)SelectObject(hdcBitmap,hBitmap);

	ret = pSurface->GetDC(&hdc);
	if(ret == DD_OK){
		BitBlt(hdc,0,0,bm.bmWidth,bm.bmHeight,hdcBitmap,0,0,SRCCOPY);
		pSurface->ReleaseDC(hdc);
	}

	SelectObject(hdcBitmap,hbmOld);
	DeleteDC(hdcBitmap);

	return (ret == DD_OK);
}

/*--------------------------------------------------------
	rbg}bvpbg쐬
---------------------------------------------------------*/
LPDIRECTDRAWPALETTE CreatePaletteFromBitmap(LPDIRECTDRAW2 pDDraw,HBITMAP hBitmap)
{
	LPDIRECTDRAWPALETTE pPalette = NULL;
	RGBQUAD rgb[256];
	PALETTEENTRY pe[256];
	int i,colors;
	HDC hdc;
	HBITMAP hbmOld;

	hdc = CreateCompatibleDC(NULL);
	hbmOld = (HBITMAP)SelectObject(hdc,hBitmap);

	colors = GetDIBColorTable(hdc,0,256,rgb);

	SelectObject(hdc,hbmOld);
	DeleteDC(hdc);

	for(i=0;i<colors;i++){
		pe[i].peRed = rgb[i].rgbRed;
		pe[i].peGreen = rgb[i].rgbGreen;
		pe[i].peBlue = rgb[i].rgbBlue;
		pe[i].peFlags = NULL;
	}

	pDDraw->CreatePalette(DDPCAPS_8BIT,pe,&pPalette,NULL);

	return pPalette;
}


/*--------------------------------------------------------
	T[tF[XɃJ[L[ݒ肷
---------------------------------------------------------*/
int SetSurfaceColorKey(LPDIRECTDRAWSURFACE3 pdds, COLORREF rgb)
{
	COLORREF rgbT;
	HDC hdc;
	DWORD dw = CLR_INVALID;
	DDSURFACEDESC ddsd;
	HRESULT hres;

	// rgbCLR_INVALID̏ꍇC摜̍̃J[L[Ԃ悤ɂD
	if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
	{
	    rgbT = GetPixel(hdc, 0, 0);
	    SetPixel(hdc, 0, 0, rgb);
	    pdds->ReleaseDC(hdc);
	}

	ddsd.dwSize = sizeof(ddsd);
	while ((hres = pdds->Lock(NULL, &ddsd, 0, NULL)) == DDERR_WASSTILLDRAWING)
	    {} ;

	if (hres == DD_OK)
	{
	    dw  = *(DWORD *)ddsd.lpSurface;
	    if(ddsd.ddpfPixelFormat.dwRGBBitCount < 32)
	        dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount)-1;
	    pdds->Unlock(NULL);
	}

	if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
	{
	    SetPixel(hdc, 0, 0, rgbT);
	    pdds->ReleaseDC(hdc);
	}

	// dwɃJ[ER[hݒ肳

	DDCOLORKEY ddck;
	ddck.dwColorSpaceLowValue = dw;
	ddck.dwColorSpaceHighValue= dw;

	return (pdds->SetColorKey(DDCKEY_SRCBLT,&ddck) == DD_OK);
}

/////////////////////////////////////////////////////////////////////////////////////////////

class D3DTexture {
    private:
	LPDIRECTDRAW2 pDDraw;
    IDirectDrawSurface *MemorySurface;  // VXeẼeNX`EC[W
    IDirectDrawSurface *DeviceSurface;  // rfIẼeNX`
	IDirectDrawPalette *Palette;
	D3DTEXTUREHANDLE    Handle;

	void ChooseTextureFormat(IDirect3DDevice2 *Device, DWORD bpp, DDPIXELFORMAT *pddpf);

    public:
        D3DTexture()
        {
	    MemorySurface = 0;
	    DeviceSurface = 0;
            Palette = 0;
	    Handle = 0;
        }

        D3DTEXTUREHANDLE    GetHandle()    {return Handle;}
        IDirectDrawSurface* GetSurface()   {return MemorySurface;}
        IDirectDrawPalette* GetPalette()   {return Palette;}

        BOOL Load(LPDIRECTDRAW2 pDDraw, IDirect3DDevice2 *Device, char *BitmapName);
        BOOL Copy(HBITMAP Bitmap);
        void Release(void);
        BOOL Restore(void);
};

/*--------------------------------------------------------------
	eNX`tH[}bgR[obN
-----------------------------------------------------------------*/
// R[obN֐ɓn\
typedef struct {
    DWORD           bpp; 	// rbg[x
    DDPIXELFORMAT   ddpfDisp;	// fBXvC̃tH[}bg
    DDPIXELFORMAT   ddpf;	// ItH[}bg
}  JDTEXTURESELECT;

HRESULT CALLBACK JDEnumTextureCallback(DDSURFACEDESC *ddsd,LPVOID lParam)
{
    JDTEXTURESELECT * FindData = (JDTEXTURESELECT *)lParam;
    DDPIXELFORMAT ddpf = ddsd->ddpfPixelFormat;

    if (ddpf.dwFlags & (DDPF_ALPHA | DDPF_ALPHAPIXELS))
        return DDENUMRET_OK;

    if (ddpf.dwRGBBitCount <= 8 && !(ddpf.dwFlags & (DDPF_PALETTEINDEXED8 | DDPF_PALETTEINDEXED4)))
        return DDENUMRET_OK;

    if (ddpf.dwRGBBitCount > 8 && !(ddpf.dwFlags & DDPF_RGB))
        return DDENUMRET_OK;

	// T[tF[XGetDC\bh͂Sbppȉł͓
	// Ȃ̂ŏO
    if (ddpf.dwRGBBitCount < 8)
        return DDENUMRET_OK;
	// rbg}bv̐F𒲂ׂ
    if (FindData->ddpf.dwRGBBitCount == 0 || (ddpf.dwRGBBitCount >= FindData->bpp &&
        (UINT)(ddpf.dwRGBBitCount - FindData->bpp) < (UINT)(FindData->ddpf.dwRGBBitCount - FindData->bpp)))
    {
    // 16rbgȏ̂ƂCRGB̔zu𒲂ׂ
        if(ddpf.dwRGBBitCount > 8){
            if(FindData->ddpfDisp.dwRBitMask & ddpf.dwRBitMask & 1)
                FindData->ddpf = ddpf;
            else if(FindData->ddpfDisp.dwBBitMask & ddpf.dwBBitMask & 1)
                FindData->ddpf = ddpf;
        }
        else
            FindData->ddpf = ddpf;
    }

    return DDENUMRET_OK;
}


/*-------------------------------------------------------------
	eNX`̃tH[}bg߂
--------------------------------------------------------------*/
void D3DTexture::ChooseTextureFormat(IDirect3DDevice2 *Device, DWORD bpp, DDPIXELFORMAT *pddpf)
{
    JDTEXTURESELECT FindData;
    ZeroMemory(&FindData, sizeof(FindData));

    DDSURFACEDESC disp;
    ZeroMemory(&disp,sizeof(DDSURFACEDESC));
    disp.dwSize = sizeof(DDSURFACEDESC);
    pDDraw->GetDisplayMode(&disp);
    FindData.ddpfDisp = disp.ddpfPixelFormat;

	FindData.bpp = bpp;
    Device->EnumTextureFormats(JDEnumTextureCallback, (LPVOID)&FindData);
    *pddpf = FindData.ddpf;
}

/*-------------------------------------------------------------
	rbg}bveNX`𐶐
--------------------------------------------------------------*/
BOOL D3DTexture::Load(LPDIRECTDRAW2 pDD, IDirect3DDevice2 *Device, char *BitmapName)
{
    BITMAP              bm;
    DDSURFACEDESC       ddsd;
    HBITMAP             Bitmap;

	pDDraw = pDD;

	Bitmap = LoadBitmapImage(BitmapName);
    if (Bitmap == NULL)
        return FALSE;

    Release();

    GetObject(Bitmap, sizeof(bm), &bm); 

    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ChooseTextureFormat(Device, bm.bmBitsPixel, &ddsd.ddpfPixelFormat);
    ddsd.dwFlags |= DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH | DDSD_PIXELFORMAT;
    ddsd.dwWidth = bm.bmWidth;
    ddsd.dwHeight = bm.bmHeight;

    D3DDEVICEDESC hal, hel;
    ZeroMemory(&hal, sizeof(hal));
    hal.dwSize = sizeof(hal);
    ZeroMemory(&hel, sizeof(hel));
    hel.dwSize = sizeof(hel);
    Device->GetCaps(&hal, &hel);

    if (hal.dcmColorModel)
        ddsd.ddsCaps.dwCaps = DDSCAPS_VIDEOMEMORY | DDSCAPS_TEXTURE | DDSCAPS_ALLOCONLOAD;
    else
        ddsd.ddsCaps.dwCaps = DDSCAPS_SYSTEMMEMORY| DDSCAPS_TEXTURE;

    if (pDDraw->CreateSurface(&ddsd, &DeviceSurface, NULL) != DD_OK)
        goto error;

    if (hal.dcmColorModel)
    {
        ddsd.ddsCaps.dwCaps = DDSCAPS_SYSTEMMEMORY | DDSCAPS_TEXTURE;

        if (pDDraw->CreateSurface(&ddsd, &MemorySurface, NULL) != DD_OK)
            goto error;
    }
    else
    {
        MemorySurface = DeviceSurface;
        DeviceSurface->AddRef();
    }

    if (ddsd.ddpfPixelFormat.dwRGBBitCount <= 8)
    {
        Palette = CreatePaletteFromBitmap(pDDraw, Bitmap);

        MemorySurface->SetPalette(Palette);
        DeviceSurface->SetPalette(Palette);
    }

    if (!Copy(Bitmap))
        goto error;

    IDirect3DTexture2 *	Texture;
    DeviceSurface->QueryInterface(IID_IDirect3DTexture2, (void**)&Texture);
    Texture->GetHandle(Device, &Handle);
    Texture->Release();

    DeleteObject(Bitmap);
    return TRUE;

error:
    if (Bitmap)
        DeleteObject(Bitmap);
    Release();
    return FALSE;
}

BOOL D3DTexture::Copy(HBITMAP Bitmap)
{
    BITMAP  bm;
    HDC     BitmapDC;
    HDC     SurfaceDC;
    BOOL    result = FALSE;

    GetObject(Bitmap, sizeof(bm), &bm);

    BitmapDC = CreateCompatibleDC(NULL);
    SelectObject(BitmapDC, Bitmap);

    if (MemorySurface->GetDC(&SurfaceDC) == DD_OK)
    {
        BitBlt(SurfaceDC, 0, 0, bm.bmWidth, bm.bmHeight, BitmapDC, 0, 0, SRCCOPY);
        MemorySurface->ReleaseDC(SurfaceDC);
        result = Restore();
    }
    DeleteDC(BitmapDC);
    return result;
}

BOOL D3DTexture::Restore()
{
    HRESULT             err;
    IDirect3DTexture2  *MemoryTexture;
    IDirect3DTexture2  *DeviceTexture;

    if (DeviceSurface == NULL || MemorySurface == NULL)
        return FALSE;

    if (DeviceSurface == MemorySurface)
        return TRUE;

    if (DeviceSurface->Restore() != DD_OK)
        return FALSE;

    DeviceSurface->QueryInterface(IID_IDirect3DTexture2, (void**)&DeviceTexture);
    MemorySurface->QueryInterface(IID_IDirect3DTexture2, (void**)&MemoryTexture);

    err = DeviceTexture->Load(MemoryTexture);

    RELEASE(DeviceTexture);
    RELEASE(MemoryTexture);

    return err == DD_OK;
}

void D3DTexture::Release()
{
	RELEASE(MemorySurface);
	RELEASE(DeviceSurface);
	RELEASE(Palette);
    Handle = 0;
}


